  { File = MAILGLOB.INC -- Include file for Reliance Mailing List globals.
    WPM, 2/24/86 }

  { COPYRIGHT (c) 1986, Wm Meacham, 1004 Elm Street, Austin, Tx  78703 }

const
    scr_fname  : string[14] = 'SCR.RML' ;    { system control file }
    mf_fname   : string[14] = 'MASTER.RML' ; { master file }
    ix1_fname  : string[14] = 'INDEX1.RML' ; { index file -- last name }
    ix2_fname  : string[14] = 'INDEX2.RML' ; { index file -- zip + last name }
    blanks     : string[30] = '                              ' ;

    wid   = 12 ;        { total width for $ amts, including decimal point }
    frac  = 2 ;         { fractional part for $ amts -- 999999999.99 }
    no_dups = 0 ;       { parameter for proc OpenIndex }
    dups_ok = 1 ;       { parameter for proc OpenIndex }
    key1_len = 6 ;      { length of key string -- 5 chars of last name }
    key2_len = 15 ;     { length of key string -- zip + 5 chars of last name }
    mf_rec_size = 216 ; { length of master record }
    max_lines = 58 ;    { maximum number of lines on printed page }

type
    str1   = string[1] ;
    str3   = string[3] ;
    str4   = string[4] ;
    str5   = string[5] ;
    str9   = string[9] ;
    str14  = string[14] ;
    str20  = string[20] ;
    str30  = string[30] ;
    str80  = string[80] ;
    str132 = string[132] ;

    option = (count, add, change, del_rec,
              contribution, list, labels, mailmerge) ;
                                   { To pick needed proc from within overlay }

    prt_criterion = (all, pcat, pct, pzip, dt, amt) ; { which names to print }
    sort_criterion = (name, szip) ;                   { how to sort }

    boolarray   = array [1 .. 8] of boolean ;
    num_str_typ = string[15] ;    { '-999,999,999.99' }

    key1_typ = str5 ;
      { The key is the first five characters of the last name, stripped of
        blanks and capitalized. }

    key2_typ = str14 ; { zip code + key1_typ }

    mf_rec = record               { Master File record }
        status     : integer ;    { 0 = active, else deleted }   { 2}
        last_name  : str30 ;                                     {31}
        frst_name  : string[18] ;                                {19}
        title      : string[9] ;  { eg, Dr., Mr., Ms., etc }     {10}
        salutation : string[11] ; { Dear ... }                   {12}
        addr1      : string[25] ;                                {26}
        addr2      : string[25] ;                                {26}
        city       : string[23] ;                                {24}
        state      : string[2] ;                                 { 3}
        zip        : str9 ;                                      {10}
        home_phon  : string[14] ;                                {15}
        work_phon  : string[14] ;                                {15}
        precinct   : str3 ;                                      { 4}
        last_amt   : real ;       { last contribution amount }   { 6}
        last_date  : date ;       { last contribution date }     { 6}
        tot_amt    : real ;       { total contribution amount }  { 6}
        flags      : byte ;       { 8 booleans, user-defined }   { 1}
    end ;                                                { total 216}

    scr_rec = record              { System Control Record }
        ID       : str30 ;        { descriptive identification }
        num_k,                    { disk capacity }
        max_rec,                  { max master records allowed }
        num_recs : integer ;      { number of records used }
        prt_init,                 { printer initialization string }
        prt_rset : str4 ;         {    "    reset string }
        cat_name : array [1..8] of str20 ; { selection category names }
    end ;

var
    scr         : scr_rec ;       { system control record }
    master      : mf_rec ;        { master record }
    key1        : key1_typ ;      { key1 work area }
    key2        : key2_typ ;      { key2 work area }

    scr_file    : file of scr_rec ;
    mf_file     : datafile ;      { master file -- type def. in ACCESS.BOX }
    ix1_file    : indexfile ;     { index file -- type def. in ACCESS.BOX }
    ix2_file    : indexfile ;     { index file -- type def. in ACCESS.BOX }

    rec_num     : integer ;       { relative record number of master rec }
    cat         : boolarray ;     { selection categories }
    choice      : integer ;       { to get menu selection }
    cur_proc_dt : date ;          { current processing date }
    drive       : str1 ;          { drive where data files exist }

    mask        : byte ;          { to select category }
    pcinct      : str3 ;          { to select precinct }
    zipcode     : str9 ;          { to select zip code }
    lastdt      : date ;          { to select date }
    contrib     : real ;          { to select amount }

{ ----- EOF MAILGLOB.INC ------------------------------------------- }
area }
    key2        : key2_typ ;      { key2 work area }

    scr_file    : file of s